 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


#---------------------------------------------------------------------------
IF(BBTK_CORE_PACKAGE)
  # If a core package set doc options from bbtk global ones
  #IF (BUILD_BBTK_DOC_PACKAGE)
  #  SET(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC ON)
  #ELSE (BUILD_BBTK_DOC_PACKAGE)
  #  SET(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC OFF)
  #ENDIF (BUILD_BBTK_DOC_PACKAGE)
  IF (BUILD_BBTK_DOC_DOXYGEN)
    SET(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC ON)
  ELSE (BUILD_BBTK_DOC_DOXYGEN)
    SET(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC OFF)
  ENDIF (BUILD_BBTK_DOC_DOXYGEN)
ELSE(BBTK_CORE_PACKAGE)
  # If not a core package 
  # Create the build doc options
  #OPTION(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC 
  #  "Build the bbtk package ${BBTK_PACKAGE_NAME} html documentation ?" OFF)
  #SWITCH_ON_IF_BUILD_ALL(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC)
  OPTION(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC 
    "Build the bbtk package ${BBTK_PACKAGE_NAME} doxygen documentation ?" OFF)
  SWITCH_ON_IF_BUILD_ALL(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC)
ENDIF(BBTK_CORE_PACKAGE)
#---------------------------------------------------------------------------

#----------------------------------------------------------------------------


#----------------------------------------------------------------------------
# Doxygen
#----------------------------------------------------------------------------
IF(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC)
  SET(${BBTK_PACKAGE_NAME}_DOXYGEN_REL_PATH ${BBTK_PACKAGE_NAME})
  ADD_SUBDIRECTORY(doxygen)
ENDIF(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_DOXYGEN_DOC)
#----------------------------------------------------------------------------



#----------------------------------------------------------------------------
# bbdoc
#---------------------------------------------------------------------------
#IF(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC)
  ADD_SUBDIRECTORY(bbdoc)
#ENDIF(BUILD_BBTK_PACKAGE_${BBTK_PACKAGE_NAME}_HTML_DOC)
#---------------------------------------------------------------------------
